; ***********************************************************************************
; * Name		:	G. Mayer 														*
; * Customer	:	Puppenhaus Stezerung - PHP2014									*
; * Datum		:	03.02.2014														*
; * 																				*
; * nderungen	:	V01 Versuchsaufbau auf Lochrasterkarte			GM 03.02.2014	*
; * 				V02 Leiterplatte V02 ohne LEDs					GM 17.02.2014	*
; * 				V03 Leiterplatte V03 ohne LEDs					GM 05.03.2014	*
; *																					*
; *  2014 dazkeiler.de																*
; ***********************************************************************************

; ***********************************************************************************
; * Fuses:																			*
; *																					*
; * OCDEN		: 	no																*
; * JTAGEN		:	no																*
; * SPIEN		:	yes																*
; * EESAVE		:	no																*
; * BOOTSZ		:	Boot Flash size=1024 words Boot address=$0C00					*
; * BOOTRST		:	no																*
; * CKOPT		:	no																*
; * BODLEVEL	:	Brown-out detection at VCC=4.0V									*
; * BODEN		:	yes																*	
; * SUT_CKSEL	:	Ext. Crystal/Resonator High Freq.; Start-up time: 16K CK + 64ms	*
; ***********************************************************************************

.include "m16def.inc"	

; ***********************************************************************************
; * Konstanten																		*
; ***********************************************************************************
.equ K_TimeIntervallPWM						= 50		; *1s = 50s
.equ K_TimeIntervall10ms					= 10000		; *1s = 10ms
.equ K_TimeIntervall100ms					= 10		; *10ms = 100ms
.equ K_TimeIntervall1000ms					= 10		; *10ms = 1000ms
.equ K_TimeStartUpDelay						= 480		; *10ms = 14,5sek 

.equ K_TimeKeyDim							= 60		; *10ms = 600ms	-> Tastenzeit, bis Taste erkannt wird
.equ K_TimeKeyDimAuto						= 40		; *10ms = 400ms	-> Zeit fr Automatisches steppen
.equ K_TimeKeyOffShort						= 30		; *10ms = 100ms
.equ K_TimeKeyOff							= 50		; *10ms = 100ms

.equ K_PrellZyclen							= 10		; *10ms = 100ms
.equ K_AusZyclen							= 10		; *10ms = 100ms

.equ K_Key01								= 0b00000001
.equ K_Key02								= 0b00000010
.equ K_Key03								= 0b00000100
.equ K_Key04								= 0b00001000
.equ K_Key05								= 0b00010000
.equ K_Key06								= 0b00100000
.equ K_Key07								= 0b01000000
.equ K_Key08								= 0b10000000

.equ K_PWMLevelMin							= 0
.equ K_PWMLevelMax							= 7
.equ K_PWMLevelOff							= 8
.equ K_PWMLevelOn							= 70
.equ K_PWMValueStart						= 20
.equ K_PWMValueOff							= 0
.equ K_PWMValueMax							= 255
.equ K_PWMSchrittweiteLangsam				= 1
.equ K_PWMSchrittweiteSchnell				= 10
;.equ K_PWMSchrittweiteSofort				= 255

; ***********************************************************************************
; * Register Zuweisungen															*
; ***********************************************************************************
;.def Reserviert fr Mathematische Einheit	= R0
;.def Reserviert fr Mathematische Einheit	= R1
;.def R_MathAL								= R0
;.def R_MathAH								= R1
;.def R_MathBL								= R2
;.def R_MathBH								= R3
;.def R_RisingTimeL							= R4
;.def R_RisingTimeH							= R5
;.def R_BitZaehler							= R6
;.def R_DataBufferByte1						= R7
;.def R_DataBufferByte2						= R8
;.def R_DataBufferByte3						= R9
;.def R_DataBufferByte4						= R10
;.def R_DataBufferByte5						= R11
;.def R_MotorCounter						= R12
;.def R_Buffer								= R13
;.def R_BTLinkCounter 						= R14
.def R_OUTPUT								= R14
.def R_PWMCounter							= R15
.def R_Prescaler100ms 						= R16
.def R_Prescaler1000ms						= R17
.def R_KEYBuffer							= R18
;.def R_KEYCounter							= R19
.def R_TastenZeit							= R20
.def R_AuszeitTaste							= R21
.def R_PrellzeitTaste	 					= R22
.def R_BellCounter							= R23
		
.def R_STATUS	 							= R24
	.equ F_10ms 							= 0					
	.equ F_100ms	 						= 1	
	.equ F_1000ms							= 2
	.equ F_TimeOut							= 3

.def R_CONTROL								= R25				; Projektbezogenes Flag Register
	.equ F_TasteKurz						= 0					; Taste wurde kurz gedrckt
	.equ F_TasteLang						= 1					; Taste wurde lang gedrckt
	.equ F_ChangeDirection					= 2
	.equ F_DIPNormalMode					= 3

;ab	R26-R31 belegt fr XL,XH,YL,YH,ZL,ZH

; ***********************************************************************************
; * RAM Bereich - Betriebswerte (knnen ber RS232 verndert werden)				*
; ***********************************************************************************
.dseg
RAM_TimeCounterL:							.byte 1
RAM_TimeCounterH:							.byte 1

RAM_KeyCode:								.byte 1

RAM_PWMSchrittweite1:						.byte 1
RAM_PWMSchrittweite2:						.byte 1
RAM_PWMSchrittweite3:						.byte 1
RAM_PWMSchrittweite4:						.byte 1
RAM_PWMSchrittweite5:						.byte 1
RAM_PWMSchrittweite6:						.byte 1
RAM_PWMSchrittweite7:						.byte 1
RAM_PWMSchrittweite8:						.byte 1

RAM_PWMIstValue1:							.byte 1
RAM_PWMIstValue2:							.byte 1
RAM_PWMIstValue3:							.byte 1
RAM_PWMIstValue4:							.byte 1
RAM_PWMIstValue5:							.byte 1
RAM_PWMIstValue6:							.byte 1
RAM_PWMIstValue7:							.byte 1
RAM_PWMIstValue8:							.byte 1

RAM_PWMSollValue1:							.byte 1
RAM_PWMSollValue2:							.byte 1
RAM_PWMSollValue3:							.byte 1
RAM_PWMSollValue4:							.byte 1
RAM_PWMSollValue5:							.byte 1
RAM_PWMSollValue6:							.byte 1
RAM_PWMSollValue7:							.byte 1
RAM_PWMSollValue8:							.byte 1

RAM_PWMCounter1:							.byte 1
RAM_PWMCounter2:							.byte 1
RAM_PWMCounter3:							.byte 1
RAM_PWMCounter4:							.byte 1
RAM_PWMCounter5:							.byte 1
RAM_PWMCounter6:							.byte 1
RAM_PWMCounter7:							.byte 1
RAM_PWMCounter8:							.byte 1

RAM_End:									.byte 1

; ***********************************************************************************
; * EEPROM Area																		*
; ***********************************************************************************
.eseg																										

; ***********************************************************************************
; * Port Konstanten Port A (Mega16)													*
; ***********************************************************************************
.equ	KeyPort								= PinA
;.equ	KeyAndLEDPort						= PortA
;.equ	KeyAndLEDDDR						= DDRA
.equ	Key01								= 0
.equ	Key02								= 1
.equ	Key03								= 2
.equ	Key04								= 3
.equ	Key05								= 4
.equ	Key06								= 5
.equ	Key07								= 6
.equ	Key08								= 7

; ***********************************************************************************
; * Port Konstanten Port B															*
; ***********************************************************************************
.equ	DIPPort								= PinB
.equ	DIP01								= 0
.equ	DIP02								= 1
.equ	LearnInPort							= PinB
.equ	LearnIn								= 2
.equ	StatusLEDPort						= PortB
.equ	StatusLED							= 3
;.equ	xXx									= PortB
;.equ	xXx									= 4
;.equ	MOSI								= 5
;.equ	MISO								= 6
;.equ	SCK									= 7

; ***********************************************************************************
; * Port Konstanten Port C															*
; ***********************************************************************************
.equ	LightPort							= PortC
.equ	Light01								= 0
.equ	Light02								= 1
.equ	Light03								= 2
.equ	Light04								= 3
.equ	Light05								= 4
.equ	Light06								= 5
.equ	Light07								= 6
.equ	Light08								= 7

; ***********************************************************************************
; * Port Konstanten Port D															*
; ***********************************************************************************
;.equ	BTRxD								= 0
;.equ	BTTxD								= 1
;.equ	xXx									= PortD
;.equ	xXx									= 2
;.equ	xXx									= PortD
;.equ	xXx									= 3
;.equ	xXx									= PortD
;.equ	xXx									= 4
;.equ	xXx									= PinD
;.equ	xXx									= 5
;.equ	xXx									= PortD
;.equ	xXx									= 6
;.equ	xXx									= PinD
;.equ	xXx									= 7

; ***********************************************************************************
; * Initialization																	*
; ***********************************************************************************
.cseg
	jmp 	RESET 											; Reset Handler
	jmp 	EXT_INT0 										; IRQ0 Handler
	jmp 	EXT_INT1 										; IRQ1 Handler
	jmp 	TIM2_COMP 										; Timer2 Compare Handler
	jmp 	TIM2_OVF 										; Timer2 Overflow Handler
	jmp		TIM1_CAPT 										; Timer1 Capture Handler
	jmp 	TIM1_COMPA_INT 									; Timer1 Compare A Handler
	jmp 	TIM1_COMPB_INT 									; Timer1 Compare B Handler
	jmp 	TIM1_OVF 										; Timer1 Overflow Handler
	jmp 	TIM0_OVF 										; Timer0 Overflow Handler
	jmp 	SPI_STC 										; SPI Transfer Complete Handler
	jmp 	USART_RxD 										; USART, RX Complete Handler
	jmp 	USART_UDRE 										; USART, UDR Empty Handler
	jmp 	USART_TxD		 								; USART, TX Complete Handler
	jmp 	ADC_INT 										; ADC Conversion Complete Handler
	jmp 	EE_RDY 											; EEPROM Ready Handler
	jmp 	ANA_COMP 										; Analog Comparator Handler
	jmp 	TWI 											; 2-wire Serial Interface Handler
	jmp		EXT_INT2										; IRQ2 Handler						(Mega16)
	jmp		TIM0_COMP										; Timer0 Compare Handler			(Mega16)
	jmp 	SPM_RDY											; Store Program Memory Ready

; ***********************************************************************************
; * Reset Handler																	*
; ***********************************************************************************
RESET:
	ldi 	XL,Low(RAMEND)									; Main program start
	out 	SPL,XL	 										; Set Stack Pointer to top of RAM
	ldi 	XL,High(RAMEND)									; Main program start
	out 	SPH,XL 											; Set Stack Pointer to top of RAM
	wdr														; reset watchdog

	; *******************************************************************************
	; * USART Init																	*
	; *******************************************************************************
;	ldi		XL,0
;	out		UBRRH,XL
;	ldi		XL,25 											; 19,2 => 25/8MHz; 38,4 => 12/8MHz 25/16MHz
;	out		UBRRL,XL
;	ldi		XL,(1<<RXCIE)|(1<<RXEN)|(1<<TXEN)
;	out		UCSRB,XL
;	ldi		XL,(1<<URSEL)|(0<<USBS)|(3<<UCSZ0)
;	out		UCSRC,XL

	wdr														; reset watchdog
	ldi		XL,0b00011000									; watchdog change enable
	out		WDTCR,XL
	ldi		XL,0b00011011									; watchdog prescal set to 125ms
	out		WDTCR,XL
	ldi		XL,0b00001011									; watchdog change disable
	out		WDTCR,XL
	wdr

; ***********************************************************************************
; * Port Deklarationen Port A														*
; ***********************************************************************************
	ldi		XL,0b11111111		; PORTA						; PullUp 	: 0 -> Nein	, 1 -> Ja
	ldi		XH,0b00000000		; DDRA	 					; Richtung 	: 0 -> Input, 1 -> Output
;                ||||||||
;                |||||||+- 0      Key01						; (Input PullUp) 			
;                ||||||+-- 1      Key02						; (Input PullUp)  													
;                |||||+--- 2      Key03						; (Input PullUp)  						
;                ||||+---- 3      Key04						; (Input PullUp) 													
;                |||+----- 4      Key05						; (Input PullUp) 
;                ||+------ 5      Key06						; (Input PullUp)	
;                |+------- 6      Key07						; (Input PullUp) 		  
;                +-------- 7      Key08						; (Input PullUp) 		 									
	out		PortA,XL
	out		DDRA,XH

; ***********************************************************************************
; * Port Deklarationen Port B														*
; ***********************************************************************************
	ldi		XL,0b00001111		; PORTB						; PullUp 	: 0 -> Nein	, 1 -> Ja
	ldi		XH,0b00001000		; DDRB	 					; Richtung 	: 0 -> Input, 1 -> Output
;                ||||||||
;                |||||||+- 0      - DIP01			 		; (Input PullUp) 			
;                ||||||+-- 1      - DIP02					; (Input PullUp)  													
;                |||||+--- 2      - LearnIn					; (Input PullUp)  						
;                ||||+---- 3      - Sound04					; (Output High) 													
;                |||+----- 4      - Sound05					; (Input) 
;                ||+------ 5      - Sound06/MOSI	 		; (Input)	
;                |+------- 6      - Sound07/MISO			; (Input) 		  
;                +-------- 7      - SCK						; (Input) 		 									
	out		PortB,XL
	out		DDRB,XH

; ***********************************************************************************
; * Port Deklarationen Port C														*
; ***********************************************************************************
	ldi		XL,0b00000000		; PORTC						; PullUp 	: 0 -> Nein	, 1 -> Ja
	ldi		XH,0b11111111		; DDRC	 					; Richtung 	: 0 -> Input, 1 -> Output
;                ||||||||
;                |||||||+- 0    - Light01					; (Output Low)	
;                ||||||+-- 1    - Light02					; (Output Low)
;                |||||+--- 2    - Light03					; (Output Low)
;                ||||+---- 3    - Light04					; (Output Low)
;                |||+----- 4    - Light05					; (Output Low)
;                ||+------ 5    - Light06					; (Output Low)
;                |+------- 6    - Light07					; (Output Low)
;                +-------- 7	- Light08					; (Output Low)
	out		PortC,XL	
	out		DDRC,XH

; ***********************************************************************************
; * Port Deklarationen Port D														*
; ***********************************************************************************
	ldi		XL,0b00000000		;PORTD						; PullUp 	: 0 -> Nein	, 1 -> Ja
	ldi		XH,0b00000000		;DDRD	 					; Richtung 	: 0 -> Input, 1 -> Output
;                ||||||||
;                |||||||+- 0  	- RxD						; (Input) 		 															 
;                ||||||+-- 1    - TxD						; (Input) 		 										
;                |||||+--- 2    - Not Used					; (Input) 			 		
;                ||||+---- 3    - Not Used					; (Input) 		 
;                |||+----- 4    - Not Used					; (Input) 		 		
;                ||+------ 5    - Not Used					; (Input) 		 						
;                |+------- 6    - Not Used					; (Input) 		 
;                +-------- 7    - DataIn					; (Input) 		 
	out		PortD,XL
	out		DDRD,XH

; ***********************************************************************************
; * MCUCR Config																	*
; ***********************************************************************************
;ldi		XL,0b10000001		; sleep enable, INT0 any logical change (Mega8)
	ldi		XL,0b01000001		; sleep enable, INT0 any logical change (Mega16)
;                ||||||||
;                |||||||+- 0    - ISC00
;                ||||||+-- 1    - ISC01
;                |||||+--- 2    - ISC10
;                ||||+---- 3    - ISC11
;                |||+----- 4    - SM0
;                ||+------ 5    - SM1
;                |+------- 6    - SE
;                +-------- 7    - SM2
	out		MCUCR,XL			; Sleepmode Enable

; ***********************************************************************************
; * TCCR0 Config -> Timer0 /64														*
; ***********************************************************************************
	ldi		XL,0b00000010
;                ||||||||
;                |||||||+- 0    - CS10
;                ||||||+-- 1    - CS11
;                |||||+--- 2    - CS12
;                ||||+---- 3    - WGM01
;                |||+----- 4    - COM00
;                ||+------ 5    - COM01
;                |+------- 6    - WGM00
;                +-------- 7    - FOC0
	out		TCCR0,XL

; ***********************************************************************************
; * TCCR1A Config 																	*
; * TCCR1B Config -> Timer1 /8 = 1Tick 1s and ICP									*
; ***********************************************************************************
	ldi		XL,0b00000000
	ldi		XH,0b10000010
;                ||||||||
;                |||||||+- 0    - CS10		/ WGM10
;                ||||||+-- 1    - CS11		/ WGM11
;                |||||+--- 2    - CS12		/ FOC1B
;                ||||+---- 3    - WGM12		/ FOC1A
;                |||+----- 4    - WGM13		/ COM1B0
;                ||+------ 5    - unused	/ COM1B1
;                |+------- 6    - ICES1		/ COM1A0
;                +-------- 7    - ICNC1		/ COM1A1
	out		TCCR1A,XL
	out		TCCR1B,XH	

; ***********************************************************************************
; * Clock Select fr Timer2 / 1024 = 1Tick 128s									*
; ***********************************************************************************
	ldi		XL,0b00000111
;                ||||||||
;                |||||||+- 0    - CS00
;                ||||||+-- 1    - CS01
;                |||||+--- 2    - CS02
;                ||||+---- 3    - CTC0
;                |||+----- 4    - unused
;                ||+------ 5    - unused
;                |+------- 6    - unused
;                +-------- 7    - unused
	out		TCCR2,XL

; ***********************************************************************************
; * Interrupts freischalten															*
; ***********************************************************************************
	in		XL,TIMSK
	ori 	XL,0b00011000
;	ldi 	XL,0b00010000
;                ||||||||
;                |||||||+- 0    - TOIE0
;                ||||||+-- 1    - OCIE0 (Mega16)	
;                |||||+--- 2    - TOIE1
;                ||||+---- 3    - OCIE1B
;                |||+----- 4    - OCIE1A
;                ||+------ 5    - TICIE1
;                |+------- 6    - TOIE2
;                +-------- 7    - OCIE2
	out		TIMSK,XL

; ***********************************************************************************
; * GICR Config -> Timer 1/64														*
; ***********************************************************************************
	ldi		XL,0b01000000			
;                ||||||||
;                |||||||+- 0    - IVCE
;                ||||||+-- 1    - IVSEL
;                |||||+--- 2    - unused
;                ||||+---- 3    - unused
;                |||+----- 4    - unused
;                ||+------ 5    - INT2
;                |+------- 6    - INT0
;                +-------- 7    - INT1	
	out		GICR,XL												; enable int0 interrupt	

; ***********************************************************************************
; * Initialisierungen																*
; ***********************************************************************************
Init:
	rcall	BasicInit											; alle Register lschen
	
	ser		XL
	mov		R_OUTPUT,XL
	clr		R_STATUS
	clr		R_CONTROL

	ldi		R_Prescaler100ms,K_TimeIntervall100ms
	ldi		R_Prescaler1000ms,K_TimeIntervall1000ms
	ldi		R_BellCounter,K_PrellZyclen
	clr		R_PWMCounter
	clr		R_KEYBuffer
;	clr		R_LEDBuffer

	ldi		R_TastenZeit,K_PrellZyclen
	ldi		R_AuszeitTaste,K_AusZyclen

	ldi		XL,K_PWMSchrittweiteLangsam
	sts		RAM_PWMSchrittweite1,XL
	sts		RAM_PWMSchrittweite2,XL
	sts		RAM_PWMSchrittweite3,XL
	sts		RAM_PWMSchrittweite4,XL
	sts		RAM_PWMSchrittweite5,XL
	sts		RAM_PWMSchrittweite6,XL
	sts		RAM_PWMSchrittweite7,XL
	sts		RAM_PWMSchrittweite8,XL

	ldi		XL,K_PWMValueOff
	sts		RAM_PWMIstValue1,XL
	sts		RAM_PWMIstValue2,XL
	sts		RAM_PWMIstValue3,XL
	sts		RAM_PWMIstValue4,XL
	sts		RAM_PWMIstValue5,XL
	sts		RAM_PWMIstValue6,XL
	sts		RAM_PWMIstValue7,XL
	sts		RAM_PWMIstValue8,XL
	sts		RAM_PWMSollValue1,XL
	sts		RAM_PWMSollValue2,XL
	sts		RAM_PWMSollValue3,XL
	sts		RAM_PWMSollValue4,XL
	sts		RAM_PWMSollValue5,XL
	sts		RAM_PWMSollValue6,XL
	sts		RAM_PWMSollValue7,XL
	sts		RAM_PWMSollValue8,XL

	ldi		XL,K_PWMLevelMax
	sts		RAM_PWMCounter1,XL
	sts		RAM_PWMCounter2,XL
	sts		RAM_PWMCounter3,XL
	sts		RAM_PWMCounter4,XL
	sts		RAM_PWMCounter5,XL
	sts		RAM_PWMCounter6,XL
	sts		RAM_PWMCounter7,XL
	sts		RAM_PWMCounter8,XL

	ldi		XL,Low(K_TimeStartUpDelay)							; Zeit Initialisieren 1. mal 
	ldi		XH,High(K_TimeStartUpDelay)
	sts		RAM_TimeCounterL,XL
	sts		RAM_TimeCounterH,XH
	sbr		R_STATUS,(1<<F_TimeOut)

	sei															; enable all interrupts

; ***********************************************************************************
; * Hauptprogramm																	*
; ***********************************************************************************
MainLoop:
	wdr
	sleep

;	sbrc	R_CONTROL,F_PacketNeu
;	call	PacketAuswertung

	sbrs	R_STATUS,F_10ms										; kommt alle 10ms
	rjmp	MainLoop

	; *********************************** 
	; * 10ms Task						*
	; *********************************** 
	cbr		R_STATUS,(1<<F_10ms) 								; clear 10ms Flag
	call	Task10ms

	sbrs	R_STATUS,F_100ms									; kommt alle 10ms
	rjmp	MainLoop

	; *********************************** 
	; * 100ms Task						*
	; *********************************** 
	cbr		R_STATUS,(1<<F_100ms)	 							; clear 100ms Flag
	call	Task100ms

	sbrs	R_STATUS,F_1000ms
	rjmp	MainLoop

	; *********************************** 
	; * 1000ms Task						*
	; *********************************** 
	cbr		R_STATUS,(1<<F_1000ms)
	rcall	Task1000ms

MainLoop_End:
	rjmp	MainLoop

; ***********************************************************************************
; * Task 10ms																		*
; ***********************************************************************************
Task10ms:
	rcall	DIPManagement
	rcall	KeyManagement
	rcall	UpdatePWMOUT01
	rcall	UpdatePWMOUT02
	rcall	UpdatePWMOUT03
	rcall	UpdatePWMOUT04
	rcall	UpdatePWMOUT05
	rcall	UpdatePWMOUT06
	rcall	UpdatePWMOUT07
	rcall	UpdatePWMOUT08
	ret

; ***********************************************************************************
; * Task 100ms																		*
; ***********************************************************************************
Task100ms:
	rcall	Light01Management
	rcall	Light02Management
	rcall	Light03Management
	rcall	Light04Management
	rcall	Light05Management
	rcall	Light06Management
	rcall	Light07Management
	rcall	Light08Management
;	rcall	TastenAuswertung									; Tasten Auswerten
;	rcall	MFKeyManagement

Task100ms_End:
	ret

; ***********************************************************************************
; * Task 1000ms																		*
; ***********************************************************************************
Task1000ms:
;	rcall	ToggleStatusLED
	ret

; ***********************************************************************************
; * Include Files																	*
; ***********************************************************************************
.include "modLIBV01.asm"
.include "modControlV01.asm"

; ***********************************************************************************
; * Interrupt fr 10ms Task															*
; ***********************************************************************************
TIM1_COMPA_INT:
	push	XH
	in		XH,SREG
	push	XL
	push	XH
	push	YL
	push	YH
	push	ZL
	push	ZH

	in		XL,OCR1AL
	in		XH,OCR1AH
	ldi		YL,Low(K_TimeIntervall10ms)
	ldi		YH,High(K_TimeIntervall10ms)
	add		XL,YL
	adc		XH,YH
	out		OCR1AH,XH
	out		OCR1AL,XL
	sbr		R_STATUS,(1<<F_10ms) 								; set 10ms Flag
;
	dec		R_Prescaler100ms
	brne	TIM1_COMPA_INT_ExtraTime

	ldi		R_Prescaler100ms,K_TimeIntervall100ms
	sbr		R_STATUS,(1<<F_100ms) 								; set 100ms Flag

	dec		R_Prescaler1000ms
	brne	TIM1_COMPA_INT_ExtraTime

	ldi		R_Prescaler1000ms,K_TimeIntervall1000ms
	sbr		R_STATUS,(1<<F_1000ms) 								; set 1000ms Flag

TIM1_COMPA_INT_ExtraTime:
	; ***************************************
	; *	Extra Zeit Counter fr TimeOut		*
	; ***************************************
	sbrc	R_STATUS,F_TimeOut
	rjmp	TIM1_COMPA_INT_End

	lds		ZL,RAM_TimeCounterL
	lds		ZH,RAM_TimeCounterH
	sbiw	ZH:ZL,1												; TimerCounter Dekrementieren
	sts		RAM_TimeCounterL,ZL
	sts		RAM_TimeCounterH,ZH
	brcc	TIM1_COMPA_INT_End

	clr		XL
	sts		RAM_TimeCounterH,XL									; Ist Counter Abgelaufen,
	sts		RAM_TimeCounterL,XL									; TimerCounter zurcksetzen
	sbr		R_STATUS,(1<<F_TimeOut)								; und Flag setzen

TIM1_COMPA_INT_End:
	pop		ZH
	pop		ZL
	pop		YH
	pop		YL
	pop		XH
	pop		XL
	out		SREG,XH
	pop		XH
	reti

; ***********************************************************************************
; * Interrupt fr 1ms PWM															*
; ***********************************************************************************
TIM1_COMPB_INT:
	push	XH
	in		XH,SREG
	push	XL
	push	XH
	push	YL
	push	YH
	push	ZL
	push	ZH


	in		XL,OCR1BL
	in		XH,OCR1BH
	ldi		YL,Low(K_TimeIntervallPWM)
	ldi		YH,High(K_TimeIntervallPWM)
	add		XL,YL
	adc		XH,YH
	out		OCR1BH,XH
	out		OCR1BL,XL

;	ser		XL
;	cp		R_PWMCounter,XL
;	brne	TIM1_COMPB_INT_PWM

;	clr		XL
;	mov		R_PWMCounter,XL										; PWM Counter neu initialisieren

TIM1_COMPB_INT_PWM:
	inc		R_PWMCounter
 	mov		XL,R_OUTPUT

	lds		XH,RAM_PWMIstValue1
	cp		R_PWMCounter,XH
	brlo	TIM1_COMPB_INT_PWMOUT1NotReady

	cbr		XL,(1<<Light01)

TIM1_COMPB_INT_PWMOUT1NotReady:
	lds		XH,RAM_PWMIstValue2
	cp		R_PWMCounter,XH
	brlo	TIM1_COMPB_INT_PWMOUT2NotReady

	cbr		XL,(1<<Light02)

TIM1_COMPB_INT_PWMOUT2NotReady:
	lds		XH,RAM_PWMIstValue3
	cp		R_PWMCounter,XH
	brlo	TIM1_COMPB_INT_PWMOUT3NotReady

	cbr		XL,(1<<Light03)

TIM1_COMPB_INT_PWMOUT3NotReady:
	lds		XH,RAM_PWMIstValue4
	cp		R_PWMCounter,XH
	brlo	TIM1_COMPB_INT_PWMOUT4NotReady

	cbr		XL,(1<<Light04)

TIM1_COMPB_INT_PWMOUT4NotReady:
	lds		XH,RAM_PWMIstValue5
	cp		R_PWMCounter,XH
	brlo	TIM1_COMPB_INT_PWMOUT5NotReady

	cbr		XL,(1<<Light05)

TIM1_COMPB_INT_PWMOUT5NotReady:
	lds		XH,RAM_PWMIstValue6
	cp		R_PWMCounter,XH
	brlo	TIM1_COMPB_INT_PWMOUT6NotReady

	cbr		XL,(1<<Light06)

TIM1_COMPB_INT_PWMOUT6NotReady:
	lds		XH,RAM_PWMIstValue7
	cp		R_PWMCounter,XH
	brlo	TIM1_COMPB_INT_PWMOUT7NotReady

	cbr		XL,(1<<Light07)

TIM1_COMPB_INT_PWMOUT7NotReady:
	lds		XH,RAM_PWMIstValue8
	cp		R_PWMCounter,XH
	brlo	TIM1_COMPB_INT_PWMOUT8NotReady

	cbr		XL,(1<<Light08)

TIM1_COMPB_INT_PWMOUT8NotReady:
	sbrc	R_CONTROL,F_DIPNormalMode
	rjmp	TIM1_COMPB_INT_SetPort

	in		XH,LightPort
	andi	XH,0b10000000										; AD Ports und Relais ignorieren
	andi	XL,0b01111111							
	or		XL,XH

TIM1_COMPB_INT_SetPort:	
	out		LightPort,XL

TIM1_COMPB_INT_End:
	pop		ZH
	pop		ZL
	pop		YH
	pop		YL
	pop		XH
	pop		XL
	out		SREG,XH
	pop		XH
	reti

EXT_INT0: 													; IRQ0 Handler
EXT_INT1: 													; IRQ1 Handler
TIM2_COMP: 													; Timer2 Compare Handler
TIM2_OVF: 													; Timer2 Overflow Handler
TIM1_CAPT:													; Timer1 Capture Handler
;TIM1_COMPA_INT:											; Timer1 Compare A Handler
;TIM1_COMPB_INT:												; Timer1 Compare B Handler
TIM1_OVF: 													; Timer1 Overflow Handler
TIM0_OVF: 													; Timer0 Overflow Handler
SPI_STC: 													; SPI Transfer Complete Handler
USART_RxD: 													; USART, RX Complete Handler
USART_UDRE: 												; USART, UDR Empty Handler
USART_TxD: 													; USART, TX Complete Handler
ADC_INT: 													; ADC Conversion Complete Handler
EE_RDY: 													; EEPROM Ready Handler
ANA_COMP: 													; Analog Comparator Handler
TWI: 														; 2-wire Serial Interface Handler
EXT_INT2:													; IRQ2 Handler							(Mega16)
TIM0_COMP:													; Timer0 Compare Handler				(Mega16)
SPM_RDY: 													; Store Program Memory Ready Handler
	reti;
