; ***********************************************************************************
; * Name		:	G. Mayer														*
; *	Description	:	Allgemeine Library 												*
; * Datum		:	03.02.2014 auf Mega16											*
; *																					*
; *  2014 dazkeiler.de																*
; *																					*
; *	Folgende Subroutines sind vorhanden												*
; * ===================================												*
; *																					*
; *	ToggleStatusLED																	*
; *																					*
; *	ToggleRelay																		*
; *	ReadAnalog																		*
; *	ReadAnalog10Bit																	*
; *	Math16Div16																		*
; *	Delay50us																		*
; *	Delay5ms																		*
; * DelayXL																			*
; *	EEpromDelete																	*
; *	EEpromToRAM																		*
; *	EEpromRead																		*
; *	EEpromWrite																		*
; * DoSPM																			*
; *	BasicInit																		*
; * 																				*
; ***********************************************************************************

; ***********************************************************************************
; * MF LED Togglen																	*
; ***********************************************************************************
ToggleStatusLED:
	sbic	StatusLEDPort,StatusLED
	rjmp	ToggleStatusLED_IsHigh
	sbi		StatusLEDPort,StatusLED
	rjmp	ToggleStatusLED_End

ToggleStatusLED_IsHigh:
	cbi		StatusLEDPort,StatusLED

ToggleStatusLED_End:
	ret

; ***********************************************************************************
; * MF LED Togglen																	*
; ***********************************************************************************
ToggleLight08:
	sbic	LightPort,Light08
	rjmp	ToggleLight08_IsHigh
	sbi		LightPort,Light08
	rjmp	ToggleLight08_End

ToggleLight08_IsHigh:
	cbi		LightPort,Light08

ToggleLight08_End:
	ret
/*		
; ***********************************************************************************
; * Relais Togglen																	*
; ***********************************************************************************
ToggleRelay:
	sbic	RelayPort,Relay
	rjmp	ToggleRelay_IsHigh
	sbi		RelayPort,Relay
	rjmp	ToggleRelay_End

ToggleRelay_IsHigh:
	cbi		RelayPort,Relay

ToggleRelay_End:
	ret

; ***********************************************************************************
; * Name: 	Read_Analog                                                            	*
; * Input:	XL = Kanal                                                             	*
; * Output:	XL = Ergebniss 8Bit		                                               	*
; * Description:                                                                   	*
; * Read the analog value and store it to XL		                               	*
; ***********************************************************************************
ReadAnalog:
	push	XH
	ori		XL,0b01100000										; VRef = AVCC = 3,3V 
	out		ADMUX,XL	      									; Wahl Analog Channel
;	ldi		XL,0b00010000	    								; ADLAR (Bit4) = 1 (left adjust)
;	out		ADCSRB,XL
	ldi		XL,0b11000100										; enable AD ;start conversion, clk/16
	out		ADCSRA,XL

ReadAnalog_Wait:												; erste Messung -> Verwerfen
	sbic    ADCSRA,ADSC											; wait until flag is clear
	rjmp	ReadAnalog_Wait
	in		XH,ADCL												; nur dummy
	in		XH,ADCH												; store to location
	ldi		XL,0b11000100										; enable AD ;start conversion, clk/16
	out		ADCSRA,XL

ReadAnalog_Wait1:												; erste Richtige Messung
	sbic    ADCSRA,ADSC											; wait until flag is clear
	rjmp	ReadAnalog_Wait1
	in		XH,ADCL												; nur dummy
	in		XH,ADCH												; store to location
	ldi		XL,0b11000100										; enable AD ;start conversion, clk/16
	out		ADCSRA,XL

ReadAnalog_Wait2:												; zweite Richtige Messung
	sbic    ADCSRA,ADSC											; wait until flag is clear
	rjmp	ReadAnalog_Wait2
	in		XL,ADCL												; nur dummy
	in		XL,ADCH												; store to location
	add		XL,XH												; addiere Messung 1 und 2 (Mittelwert Bildung)
	ror		XL													; /2
	cbi		ADCSRA,ADEN											; disable Konverter
	pop		XH

ReadAnalog_End:
	ret
	*/
/*
; ***********************************************************************************
; * Name: 		Read_Analog 10Bit                                                   *
; * Input:		XL = Kanal                                                          *
; * Output:		XL:XH = Ergebniss 10Bit                                             *
; * Description:                                                                    *
; * Read the analog value and store it to XL:XH	                                    *
; ***********************************************************************************
ReadAnalog10Bit:
	push	YL
	push	YH
	ori		XL,0b10000000										; Internal VRef 1,1V
	out		ADMUX,XL	      									; Wahl Analog Channel
	ldi		XL,0b00000000	    								; ADLAR (Bit4) = 0 (right adjust)
	out		ADCSRB,XL
	ldi		XL,0b11000100										; enable AD ;start conversion, clk/16
	out		ADCSRA,XL

ReadAnalog10Bit_Wait:											; erste Messung -> Verwerfen
	sbic    ADCSRA,ADSC											; wait until flag is clear
	rjmp	ReadAnalog10Bit_Wait
	in		XL,ADCL												; nur dummy
	in		XH,ADCH												; store to location
	ldi		YL,0b11000100										; enable AD ;start conversion, clk/16
	out		ADCSRA,YL

ReadAnalog10Bit_Wait1:											; erste Richtige Messung
	sbic    ADCSRA,ADSC											; wait until flag is clear
	rjmp	ReadAnalog10Bit_Wait1
	in		XL,ADCL												; nur dummy
	in		XH,ADCH												; store to location
	ldi		YL,0b11000100										; enable AD ;start conversion, clk/16
	out		ADCSRA,YL

ReadAnalog10Bit_Wait2:											; zweite Richtige Messung
	sbic    ADCSRA,ADSC											; wait until flag is clear
	rjmp	ReadAnalog10Bit_Wait2
	in		YL,ADCL												; nur dummy
	in		YH,ADCH												; store to location
	add		XL,YL												; addiere Messung 1 und 2 (Mittelwert Bildung)
	adc		XH,YH
	lsr		XH													; /2
	ror		XL													;
	cbi		ADCSRA,ADEN											; disable Konverter
	pop		YH
	pop		YL

ReadAnalog10Bit_End:
	ret
*/
/*
; ***********************************************************************************
; * Name: 	Math16Div16                                                           	*
; * input:	R_MathAL,R_MathAH(16bit) = dividend                                 	*
; *			R_MathBL,R_MathBH(16bit) = divisor                                  	*
; * output:	R_MathAL,R_MathAH(16Bit) = result                                   	*
; *			R_MathBL,R_MathBH(16Bit) = remainder                                	*
; * Description:                                                                    *
; * make a 16Bit / 16 Bit division										           	*
; ***********************************************************************************
Math16Div16:
	push	XL
	push	XH
	push	YL
	clr		XL													; clear remainder Low byte
	sub		XH,XH												; clear remainder High byte and carry
	ldi		YL,17												; init loop counter

Math16Div16_1:
	rol		R_MathAL											; shift left dividend
	rol		R_MathAH
	dec		YL													; decrement counter
	brne	Math16Div16_2										; if done
	mov		R_MathBL,XL
	mov		R_MathBH,XH
	pop		YL
	pop		XH
	pop		XL
	ret															; return

Math16Div16_2:
	rol		XL													;  shift dividend into remainder
	rol		XH
	sub		XL,R_MathBL											; remainder = remainder - divisor
	sbc		XH,R_MathBH						
	brcc	Math16Div16_3										; if result negative
	add		XL,R_MathBL											; restore remainder
	adc		XH,R_MathBH		
	clc															; clear carry to be shifted into result
	rjmp	Math16Div16_1										; else

Math16Div16_3:	
	sec															; set carry to be shifted into result
	rjmp	Math16Div16_1          								; rotieren: weitermachen

; ***********************************************************************************
; * Pause nach jeder bertragung													*
; *********************************************************************************** 
Delay50us:                             							; 50s Pause (bei 8 MHz)
	push	XL
	ldi  	XL,128

Delay50us_Loop:
	dec  	XL
	brne 	Delay50us_Loop

	pop		XL
	ret                          								; wieder zurck

; ***********************************************************************************
; * Lngere Pause fr manche Befehle												*
; *********************************************************************************** 
Delay5ms:                               						; 5ms Pause (bei 8 MHz)
	push	XL
	push	XH
	ldi  	XL,52

Delay5ms_Loop1:   
	ldi  	XH,255

Delay5ms_Loop2:   
	dec  	XH
	brne 	Delay5ms_Loop2
	
	dec  	XL
	brne 	Delay5ms_Loop1
	
	pop		XH
	pop		XL
	ret                          								; wieder zurck

; ***********************************************************************************
; * Wartezeit 																		*
; * XL = Zeit => XL*10ms										 					*
; ***********************************************************************************
DelayXL:
DelayXL_Loop:
	wdr
	sbrs	R_STATUS,F_10ms
	rjmp	DelayXL_Loop

	cbr		R_STATUS,(1<<F_10ms)
	dec		XL
	brne	DelayXL_Loop

DelayXL_End:
	ret

; ***********************************************************************************
; * Name: 			EEprom_Read														*
; * input:			ZL,ZH (Zeiger)													*
; * output:			XL																*
; * Description:    bernimmt mit ZL, ZH die EEPROM-Adresse und  					*
; *  				liest den entspr. Wert in XL aus  								*
; ***********************************************************************************
EEpromRead:
;	cbi		StatusLEDPort,StatusLED
	sbic 	EECR,EEWE											; Wait for completion of previous write
	rjmp 	EEpromRead
	out 	EEARH,ZH											; Set up address (YL:YH) in address register
	out 	EEARL,ZL
	sbi 	EECR,EERE											; Start eeprom read by writing EERE
	in 		XL,EEDR												; Read data from data register
;	sbi		StatusLEDPort,StatusLED
	ret

; ***********************************************************************************
; * Name: 			EEprom_Write und Wait											*
; * input:			ZL,ZH (Zeiger), XL (Wert)										*
; * output:																			*
; * Description:	bernimmt mit ZL, ZH die EEPROM-Adresse und						*
; *  				speichert den entspr. Wert aus XL 								*
; ***********************************************************************************
EEpromWrite:
;	cbi		StatusLEDPort,StatusLED
	sbic 	EECR,EEWE											; Wait for completion of previous write
	rjmp 	EEpromWrite
	out 	EEARH,ZH											; Set up address (YL:YH) in address register
	out 	EEARL,ZL
	out 	EEDR,XL												; Write data (XL) to data register
	cli															; disable all interrupts
	sbi 	EECR,EEMWE											; Write logical one to EEMWE
	sbi 	EECR,EEWE											; Start eeprom write by setting EEWE
	sei															; enable all interrupts
;	sbi		StatusLEDPort,StatusLED
	ret

; ***********************************************************************************
; * Name: 			EEprom_Write und Wait ohne Interrupts zu deaktivieren			*
; * input:			ZL,ZH (Zeiger), XL (Wert)										*
; * output:																			*
; * Description:	bernimmt mit ZL, ZH die EEPROM-Adresse und						*
; *  				speichert den entspr. Wert aus XL 								*
; ***********************************************************************************
EEpromWriteWithoutEnableInteruppts:
;	cbi		StatusLEDPort,StatusLED
	sbic 	EECR,EEWE											; Wait for completion of previous write
	rjmp 	EEpromWriteWithoutEnableInteruppts
	out 	EEARH,ZH											; Set up address (YL:YH) in address register
	out 	EEARL,ZL
	out 	EEDR,XL												; Write data (XL) to data register
	sbi 	EECR,EEMWE											; Write logical one to EEMWE
	sbi 	EECR,EEWE											; Start eeprom write by setting EEWE
;	sbi		StatusLEDPort,StatusLED
	ret	
*/
; ***********************************************************************************
; * RAM und Register Initialisieren													*
; * my_RAM_END	: .byte 1 muss an Letzter Stelle der RAM definition stehen			*
; ***********************************************************************************
BasicInit:
	; *******************************************************************************
	; * SRAM lschen 																*
	; *******************************************************************************
	ldi		XL,Low(SRAM_START)
    ldi     XH,High(SRAM_START)
    clr		YL

BasicInit_SRAM_Loop:
    st      X+,YL
    ldi     YH,High(RAM_END)
    cpi     XL,Low(RAM_END)
    cpc     XH,YH
    brne    BasicInit_SRAM_Loop

	; *******************************************************************************
    ; * R0 - R31 lschen	 														*
	; *******************************************************************************
    ldi     XL,0
    ldi     XH,0
    ldi     YL,0

BasicInit_Register_Loop:
    st      X+,YL
    cpi     XL,26
    brne    BasicInit_Register_Loop
    clr     XL
    clr     XH
    clr     YL
    clr     YH
    clr     ZL
    clr     ZH
    ret
